{$O+,Q-,R-,S-}
program pic; //Author: Kristiyan Haralambiev (Bs), Sofia - May 14.05.2002
{$APPTYPE CONSOLE}
uses
  SysUtils;
const
     InFile                     = 'pic.inp';
     OutFile                    = 'pic.out';
     MaxN                       = 151;
     MaxM                       = 1501;
type
    PNode                       = ^TNode;
    TNode                       = record
                                    Num : Integer;
                                    Fail : PNode;
                                    Edge : array[0..255] of PNode; //array[Colors]
                                  end;
var
   Pat                          : array[1..MaxN,1..MaxN] of Byte; //of Color
   PatNode                      : array[0..MaxN,0..MaxN] of PNode;
   Ppat                         : array[1..MaxN] of PNode;
   Search                       : array[1..MaxN] of Byte; //of 1..MaxN
   SP, SP_                      : array[0..MaxN] of Byte; //of 1..MaxN
   Tex                          : array[1..MaxM*MaxM] of Byte;  //of Color
   Occur                        : array[1..MaxM,1..MaxM] of Byte; //of 1..MaxN
   Ni, Nj, Mi, Mj, Size, Ans    : Integer;
   Root                         : PNode;
   Fi, Fo                       : Text;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
   I, J                         : Integer;
begin
  for I := 1 to Ni do Search[I] := I;

//reading small picture
  for I := 1 to Ni do begin
    for J := 1 to Nj do Read(Fi, Pat[I,J]);
    ReadLn(Fi);
  end;

//reading big picture
  Size := 0;
  for I := 1 to Mi do begin
    for J := 1 to Mj do begin
      Inc(Size);
      Read(Fi, Tex[Size]);
    end;
    Inc(Size);
    Tex[Size] := 0;
    ReadLn(Fi);
  end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InitNode(var P : Pnode; Num : Integer; Fail : Pnode; I, J : Integer);
begin
  New(P);
  P^.Num := Num;
  P^.Fail := Fail;
  FillChar(P^.Edge, SizeOf(P^.Edge), 0);

  PatNode[I,J] := P;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure BuildTree;
var
   I, J                         : Integer;
   Prev, CurFail                : PNode;
   C                            : Byte;
begin
  FillChar(PatNode, SizeOf(PatNode), 0);

//init for the root of the tree
  InitNode(Root,0,nil,0,0);
  
//making the first level
  for I := 1 to Ni do begin
    C := Pat[I,1];
    if Root^.Edge[C] = nil then InitNode(Root^.Edge[C],0,Root,I,1);
    Ppat[I] := Root^.Edge[C];
    if Nj = 1 then
      if Ppat[I]^.Num = 0 then Ppat[I]^.Num := I
                           else Search[I] := Ppat[I]^.Num;
  end;
  
//making the other levels
  for J := 2 to Nj do
    for I := 1 to Ni do begin
      Prev := Ppat[I];
      C := Pat[I,J];
      if Prev^.Edge[C] = nil then begin
        InitNode(Prev^.Edge[C],0,nil,I,J);
        Ppat[I] := Prev^.Edge[C];

        CurFail := Prev^.Fail;
        while (CurFail <> Root) and
              (CurFail^.Edge[C] = nil) do CurFail := CurFail^.Fail;
        if CurFail^.Edge[C] = nil then Ppat[I]^.Fail := Root
                                  else Ppat[I]^.Fail := CurFail^.Edge[C];
      end
      else begin
        Ppat[I] := Prev^.Edge[C];
      end;
    end; //for I := ...
    
//labeling final nodes
  for I := 1 to Ni do
     if Ppat[I]^.Num = 0 then Ppat[I]^.Num := I
                         else Search[I] := Ppat[I]^.Num;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
   W                            : PNode;
   C, Cindex, K, V, J           : Integer;
begin
  FillChar(Occur, SizeOf(Occur), 0);

//part 1 - Aho-Corasick:
//patterns - rows of small pic
//text - concatenated rows of big pic separated with color 0
  C := Tex[1]; Cindex := 1;//ReadF(C);
  W := Root;
  repeat
    while W^.Edge[C] <> nil do begin
      W := W^.Edge[C];
      if W^.Num > 0 then begin
        Occur[Cindex div (Mj+1) + 1, Cindex mod (Mj+1) + 1 - Nj] := W^.Num;
      end;
      //ReadF(C);
      Inc(Cindex);
      if Cindex > Size then begin W := Root; Break; end
                       else C := Tex[Cindex];
    end;

    if W <> Root then W := W^.Fail
    else begin //ReadF(C);
      Inc(Cindex);
      if Cindex > Size then Break
                       else C := Tex[Cindex];
    end;
  until False;


//part 2 - KMP: occurrences of Search in each column of Occur;
  Search[Ni+1] := 0;
  //preprocessing - computing SP(i) values
  SP[0] := 0; SP[1] := 0;
  for K := 2 to Ni do begin
    V := SP[K-1];
    while (Search[V+1] <> Search[K]) and (V <> 0) do V := SP[V];
    if Search[V+1] = Search[K]
      then SP[K] := V+1
      else SP[K] := 0;

  end;
  //optimizing SP values - computing SP'(i) values
  SP_[0] := 0; SP_[1] := 0;
  for K := 2 to Ni do
    if Search[ SP[K]+1 ] <> Search[K+1]
      then SP_[K] := SP[K]
      else SP_[K] := SP_[ SP[K] ];
  //running KMP algorithm & computing the answer
  Ans := 0;
  for J := 1 to Mj do begin
    C := 1;
    K := 1;
    while C + (Ni-K) <= Mi do begin
      while (Search[K] = Occur[C,J]) and (K <= Ni) do begin
        Inc(K);
        Inc(C);
      end;
      if K = Ni+1 then Inc(Ans);
      if K = 1 then Inc(C);
      K := SP_[K-1]+1;
    end;
  end;
end;
// Don't you think that Aho-Corasick and KMP are quite alike!?
// They are!!! - Aho-Corasick is a kind of generalized KMP

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure ClearTree;
var
        I, J                            : Integer;
begin
  for I := 1 to Ni do
    for J := 1 to Nj do
      if PatNode[I,J] <> nil then DisPose(PatNode[I,J]);
  DisPose(PatNode[0,0]); //root
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Init;
begin
  Assign(Fi, InFile); ReSet(Fi);
  Assign(Fo, OutFile); ReWrite(Fo);

  ReadLn(Fi, Nj, Ni, Mj, Mi);
  repeat
    InPut;
    BuildTree;
    Go;
    ClearTree;
    WriteLn(Fo, Ans);
    ReadLn(Fi, Nj, Ni, Mj, Mi);
  until Ni = 0;

  Close(Fi); Close(Fo);
end;
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  Init;
end.

